<?php

/**
*
* @package install
* @version $Id: functions_ipb13.php,v 0.1 2008/02/16 10:00:00 maat Exp $
* @copyright (c) 2008 grenouille.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License V3
*
*/

/**
* Helper functions for ipb 1.3 to phpBB 3.0.x conversion
*/

/**
* Get choices count and populate POLL_OPTIONS_TABLE
*/
function update_ipb_polls()
{
	error_log("update_ipb_polls",0);
}

// TODO : Rework needed
function phpbb_poll($choices)
{
	error_log("Choices :".$choices);
	global $db,$src_db,$convert;
	$poll=unserialize($choices);
	$count=0;
	$sql = 'TRUNCATE TABLE '.POLL_OPTIONS_TABLE;
	$db->sql_query($sql);

	if ( ! empty($poll))
	{
		foreach($poll as $k =>$v)
		{
			$sql = "SELECT {$convert->src_table_prefix}topics.tid
			FROM {$convert->src_table_prefix}topics,{$convert->src_table_prefix}polls
			WHERE {$convert->src_table_prefix}topics.tid={$convert->src_table_prefix}polls.tid and {$convert->src_table_prefix}polls.pid = ".$k;
			$result = $src_db->sql_query($sql);
			$topic = (int) $src_db->sql_fetchfield('tid');
			$src_db->sql_freeresult($result);
			foreach($poll[$k]['choice'] as $kk =>$vk)
			{
				$sql_ary['poll_option_id']=$kk;
				$sql_ary['poll_option_text']=$vk;
				$sql_ary['poll_option_total']=$poll[$k]['votes'][$kk];
				$sql_ary['topic_id']=$topic;
				$sql = 'INSERT INTO '.POLL_OPTIONS_TABLE.' '.$db->sql_build_array('INSERT', $sql_ary);
				$db->sql_query($sql);
			}
			$count=count($poll[$k]['choice']);
		}
	}
	else
	{
		$count=0;
	}
	return $count;
}

/**
* Set forum flags - only prune old polls by default
*/
function phpbb_forum_flags()
{
// Set forum flags
$forum_flags = 0;

// FORUM_FLAG_LINK_TRACK
$forum_flags += 0;

// FORUM_FLAG_PRUNE_POLL
$forum_flags += FORUM_FLAG_PRUNE_POLL;

// FORUM_FLAG_PRUNE_ANNOUNCE
$forum_flags += 0;

// FORUM_FLAG_PRUNE_STICKY
$forum_flags += 0;

// FORUM_FLAG_ACTIVE_TOPICS
$forum_flags += 0;

// FORUM_FLAG_POST_REVIEW
$forum_flags += FORUM_FLAG_POST_REVIEW;

return $forum_flags;
}

/**
* Function to clean phpBB3 binary SQL tree
*
* @param int $forum_id id of forum to clean
* @param int $left initial value for binary tree left_id values
*/
function ibp_clean_forum_tree ( $forum_id, $left)
{
	global $db, $src_db;

	// the right value of this node is the left value + 1
	// If it has childs then this value will grow
	$right = $left+1;
	
	// get all children of this node
	$sql = 'SELECT forum_id FROM '. FORUMS_TABLE .
				' WHERE parent_id="'.$forum_id.'";';

	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		// recursive execution of this function for each
		// child of this node
		// $right is the current right value, which is
		// incremented by the rebuild_tree function
		$right = ibp_clean_forum_tree($row['forum_id'], $right);
	}
	$db->sql_freeresult($result);

	// we've got the left value, and now that we've processed
	// the children of this node we also know the right value
	$sql2='UPDATE ' . FORUMS_TABLE . ' SET left_id='.$left.', right_id='.
		$right.' WHERE forum_id="'.$forum_id.'";';
	$db->sql_query($sql2); 
	
	// return the right value of this node + 1
	return $right+1;
}

/**
* Insert/Convert forums
*/
function phpbb_insert_forums()
{
	global $db, $src_db, $same_db, $convert, $user, $config;
	
	$db->sql_query($convert->truncate_statement . FORUMS_TABLE);

	$max_forum_cat_id = 1;
		
	// TODO : Fix that
	// pruning disabled globally?
	//$sql = "SELECT conf_value
	//	FROM {$convert->src_table_prefix}conf_settings
	//	WHERE conf_key = 'prune_enable'";
	//$result = $src_db->sql_query($sql);
	//$prune_enabled = (int) $src_db->sql_fetchfield('conf_value');
	//$src_db->sql_freeresult($result);
	$prune_enabled=0;
	
	// Determine the highest id used within the old forums table
	// This is needed because we add the categories with higher
	// ids than the forums so that we dont need to change forums
	$sql = 'SELECT MAX(id) AS max_forum_id
		FROM ' . $convert->src_table_prefix . 'forums';
	$result = $src_db->sql_query($sql);
	$max_ipb_forum_id = (int) $src_db->sql_fetchfield('max_forum_id');
	$src_db->sql_freeresult($result);
	
	$max_forum_id=$max_ipb_forum_id+1;

	// First : we deal with categories
	$sql_ipb_cat = 'SELECT id, name, position, state  
		FROM ' . $convert->src_table_prefix . 'categories WHERE id!=-1 ORDER BY position';

	if ($convert->mysql_convert && $same_db)
	{
		$src_db->sql_query("SET NAMES 'binary'");
	}
	
	$result = $src_db->sql_query($sql_ipb_cat);
	
	if ($convert->mysql_convert && $same_db)
	{
		$src_db->sql_query("SET NAMES 'utf8'");
	}

	switch ($db->sql_layer)
	{
		case 'mssql':
		case 'mssql_odbc':
		$db->sql_query('SET IDENTITY_INSERT ' . FORUMS_TABLE . ' ON');
		break;
	}

	$cats_added = array();
	while ($row = $src_db->sql_fetchrow($result))
	{
		$sql_ary = array(
		'forum_id'      => (int) $max_forum_id,
		'forum_name'   => ($row['name']) ? iconv('iso8859-8','utf-8',$row['name']) : $user->lang['CATEGORY'],
		'parent_id'      => 0,
		'forum_parents'   => '',
		'forum_desc'   => '',
		'forum_type'   => FORUM_CAT,
		'forum_status'   => ITEM_UNLOCKED,
		'forum_rules'   => '',
		);
	
		$sql = 'SELECT MAX(right_id) AS right_id
		FROM ' . FORUMS_TABLE;
		$_result = $db->sql_query($sql);
		$cat_row = $db->sql_fetchrow($_result);
		$db->sql_freeresult($_result);
	
		$sql_ary['left_id'] = (int) ($cat_row['right_id'] + 1);
		$sql_ary['right_id'] = (int) ($cat_row['right_id'] + 2);
	
		$sql = 'INSERT INTO ' . FORUMS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
		$db->sql_query($sql);
	
		$cats_added[$row['id']] = $max_forum_id;
		$max_forum_id++;
	}
	$src_db->sql_freeresult($result);

	
	// Second : we deal with forums
	$sql = 'SELECT id, parent_id, category, name, description, status FROM ' . $convert->src_table_prefix . 'forums
		ORDER BY position';
	
	if ($convert->mysql_convert && $same_db)
	{
		$src_db->sql_query("SET NAMES 'binary'");
	}
	
	$result = $src_db->sql_query($sql);
	
	if ($convert->mysql_convert && $same_db)
	{
		$src_db->sql_query("SET NAMES 'utf8'");
	}
	
	while ($row = $src_db->sql_fetchrow($result))
	{
		//define the parent
		if ( $row['parent_id'] == -1 )
		{
			$forum_parent_id=(int) $cats_added[$row['category']];
		}
		else
		{
			$forum_parent_id=$row['parent_id'];
		}

		// Define the new forums sql ary
		$sql_ary = array(
		'forum_id'         => (int) $row['id'],
		'forum_name'      => iconv('iso8859-8','utf-8',$row['name']),
		'parent_id'         => $forum_parent_id,
		'forum_parents'      => 0,
		'forum_desc'      => iconv('iso8859-8','utf-8',$row['description']),
		'forum_type'      => FORUM_POST,
		'forum_status'      => is_item_locked(not($row['status'])),
		'enable_prune'      => 0,
		'prune_next'      => 0,
		'prune_days'      => 0,
		'prune_viewed'      => 0,
		'prune_freq'      => 0,
	
		'forum_flags'      => phpbb_forum_flags(),
	
		// Default values
		'forum_desc_bitfield'      => '',
		'forum_desc_options'      => 7,
		'forum_desc_uid'         => '',
		'forum_link'            => '',
		'forum_password'         => '',
		'forum_style'            => 0,
		'forum_image'            => '',
		'forum_rules'            => '',
		'forum_rules_link'         => '',
		'forum_rules_bitfield'      => '',
		'forum_rules_options'      => 7,
		'forum_rules_uid'         => '',
		'forum_topics_per_page'      => 0,
		'forum_posts'            => 0,
		'forum_topics'            => 0,
		'forum_topics_real'         => 0,
		'forum_last_post_id'      => 0,
		'forum_last_poster_id'      => 0,
		'forum_last_post_subject'   => '',
		'forum_last_post_time'      => 0,
		'forum_last_poster_name'   => '',
		'forum_last_poster_colour'   => '',
		'display_on_index'         => 1,
		'enable_indexing'         => 1,
		'enable_icons'            => 0,
		);
		
		$sql_ary['left_id'] = 0;
		$sql_ary['right_id'] = 0;
	
		$sql = 'INSERT INTO ' . FORUMS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
		$db->sql_query($sql);
	}
	$src_db->sql_freeresult($result);

	// Rebuilding binrary trees
	$next_left=1;
	foreach ( $cats_added as $cat_forum_id )
	{
		$next_left=ibp_clean_forum_tree ( $cat_forum_id, $next_left);
	}
	
	
	switch ($db->sql_layer)
	{
		case 'postgres':
		$db->sql_query("SELECT SETVAL('" . FORUMS_TABLE . "_seq',(select case when max(forum_id)>0 then max(forum_id)+1 else 1 end from " . FORUMS_TABLE . '));');
		break;
	
		case 'mssql':
		case 'mssql_odbc':
		$db->sql_query('SET IDENTITY_INSERT ' . FORUMS_TABLE . ' OFF');
		break;
	
		case 'oracle':
		$result = $db->sql_query('SELECT MAX(forum_id) as max_id FROM ' . FORUMS_TABLE);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
	
		$largest_id = (int) $row['max_id'];
	
		if ($largest_id)
		{
		$db->sql_query('DROP SEQUENCE ' . FORUMS_TABLE . '_seq');
		$db->sql_query('CREATE SEQUENCE ' . FORUMS_TABLE . '_seq START WITH ' . ($largest_id + 1));
		}
		break;
	}
}

/**
* Function for recoding text with the default language
*
* @param string $text text to recode to utf8
* @param bool $grab_user_lang if set to true the function tries to use $convert_row['user_lang'] (and falls back to $convert_row['poster_id']) instead of the boards default language
*/
function phpbb_set_encoding($text, $grab_user_lang = true)
{
	return iconv('iso8859-8','utf-8',$text);
}

/**
* Same as phpbb_set_encoding, but forcing boards default language
*/
function phpbb_set_default_encoding($text)
{
	return phpbb_set_encoding($text, false);
}

/**
* Return correct user id value
* Everyone's id will be one higher to allow the guest/anonymous user to have a positive id as well
*/
function phpbb_user_id($user_id)
{
	global $config;
	
	// If the old user id is 0, it is the anonymous user...
	if ($user_id == 0)
	{
		return ANONYMOUS;
	}

	// Increment user id if the old forum is having a user with the id 1
	if ( $user_id == 1 )
	{
		set_config('increment_user_id', 1, true);
		$config['increment_user_id'] = 1;
	}
		
	return (int)($user_id + (int)$config['increment_user_id']);
}

/* Copy additional table fields from old forum to new forum if user wants this (for Mod compatibility for example)
function phpbb_copy_table_fields()
{
}
*/

/**
* Convert authentication
* user, group and forum table has to be filled in order to work
* Currently only gives rather rough conversion and only for groups
* specific urer perms are not converted at all
*/
function phpbb_convert_authentication()
{
	global $db, $src_db, $same_db, $convert, $user, $config, $cache;
	
	if ( (int)$config['increment_user_id'] == 1 )
	{
		$sql_id="(id + 1)";
	}
	else
	{
		$sql_id="id";
	}
	
	// Get phpbb bot group_id...
	$sql = 'SELECT group_id
		FROM ' . GROUPS_TABLE . "
		WHERE group_name = '" . $db->sql_escape('BOTS') . "'";
	$result = $db->sql_query($sql);
	$bot_group_id = (int) $db->sql_fetchfield('group_id');
	$db->sql_freeresult($result);

	// get permission masks and associated groups
	$sql_ipb_perms = 'SELECT perm_id, perm_name 
		FROM ' . $convert->src_table_prefix . 'forum_perms;';
	$result_ipb_perms = $src_db->sql_query($sql_ipb_perms);
	$ipb13_standard_masks = array();
	$ipb13_groups_in_mask = array();
	while ($row = $src_db->sql_fetchrow($result_ipb_perms))
	{
		//error_log($row['perm_name'] . " : " . $row['perm_id']);
		$ipb13_standard_masks[$row['perm_name']] = $row['perm_id'];
		$ipb13_groups_in_mask[$row['perm_id']]=array();
	}
	$db->sql_freeresult($result_ipb_perms);
	
	/* STATIC OLD VERSION
	$ipb13_standard_masks=Array(
	'Validating' => 1,
	'Guest' => 2,
	'Member' => 3,
	'Admin' => 4,
	'Banned' => 5
		);
	*/
	
	// get custom groups for each standard mask
	$sql_groups_in_mask = 'SELECT g_id, g_title, g_perm_id FROM ' . $convert->src_table_prefix . 'groups ';
	
	$results_groups_in_mask = $src_db->sql_query($sql_groups_in_mask);
	$ipb13_groups_in_mask = array();
	$ipb13_groups=array();
	while ($row = $src_db->sql_fetchrow($results_groups_in_mask))
	{
		//$ipb13_groups_in_mask[$mask]=array(3=>3,4=>4...)
		unset($i_group);
		unset($i_mask_array);
		$i_group=$row['g_id'];
		$ipb13_groups[$i_group]['id']=$i_group;
		$ipb13_groups[$i_group]['name']=$row['g_title'];
		$i_mask_array=explode (',',$row['g_perm_id']);
		foreach ( $i_mask_array as $i_mask )
		{
			$ipb13_groups_in_mask[$i_mask][$i_group]=$i_group;
		}
	}
	$db->sql_freeresult($results_groups_in_mask);
	
	
	// parse forums
	$sql_parse_forums = 'SELECT id, name, start_perms, reply_perms, read_perms, upload_perms FROM ' . 
		$convert->src_table_prefix . 'forums';
	$result_parse_forums = $src_db->sql_query($sql_parse_forums);
	
	$forums=array();
	$ipb13_perms=array();
	while ($row = $src_db->sql_fetchrow($result_parse_forums))
	{
		$forum_id=$row['id'];
		$forums[$forum_id]['id']=$forum_id;
		
		unset($start_perms_array);
		$start_perms_array = explode (',',$row['start_perms']);
		
		foreach ($start_perms_array as $i_mask)
		{
			foreach ($ipb13_groups_in_mask[$i_mask] as $i_group)
			{
				// error_log("$i_group can start a topic on $forum_id");
				$ipb13_perms[$forum_id][$i_group]['start']=true;
			}
		}
		
		unset($reply_perms_array);
		$reply_perms_array = explode (',',$row['reply_perms']);
		
		foreach ($reply_perms_array as $i_mask)
		{
			foreach ($ipb13_groups_in_mask[$i_mask] as $i_group)
			{
				// error_log("$i_group can reply in $forum_id");
				$ipb13_perms[$forum_id][$i_group]['reply']=true;
			}
		}
		
		unset($read_perms_array);
		$read_perms_array = explode (',',$row['read_perms']);
		
		foreach ($read_perms_array as $i_mask)
		{
			foreach ($ipb13_groups_in_mask[$i_mask] as $i_group)
			{
				// error_log("$i_group can read $forum_id");
				$ipb13_perms[$forum_id][$i_group]['read']=true;
				
			}
		}
		
		unset($upload_perms_array);
		$upload_perms_array = explode (',',$row['upload_perms']);

		foreach ($upload_perms_array as $i_mask)
		{
			foreach ($ipb13_groups_in_mask[$i_mask] as $i_group)
			{
				// error_log("$i_group can upload in $forum_id");
				$ipb13_perms[$forum_id][$i_group]['upload']=true;
				
			}
		}
		
	}
	$src_db->sql_freeresult($result_parse_forums);

	// Clearing phpbb ACLs
	$db->sql_query($convert->truncate_statement . ACL_USERS_TABLE);
	$db->sql_query($convert->truncate_statement . ACL_GROUPS_TABLE);
		
	// System groups
		
	// Seting admins as founders
	$sql = 'UPDATE ' . USERS_TABLE . '
		SET user_type = ' . USER_FOUNDER . "
		WHERE group_id = ".get_group_id('administrators');
	$db->sql_query($sql);
	
	// Seting admins as admins and global moderators
	$auth_sql_admin = "SELECT ".$sql_id." as user_id, {ADMINISTRATORS} FROM " . 
		$convert->src_table_prefix . "members WHERE mgroup = 4";
	user_group_auth('administrators', $auth_sql_admin, true);
		
	$auth_sql_global_mod = "SELECT ".$sql_id." as user_id, {GLOBAL_MODERATORS} FROM " . 
		$convert->src_table_prefix . "members WHERE mgroup = 4";
	user_group_auth('global_moderators', $auth_sql_global_mod, true);

	// Setting anonymous as guest
	user_group_auth('guests', 'SELECT user_id, {GUESTS} FROM ' . 
		USERS_TABLE . ' WHERE user_id = ' . ANONYMOUS, false);

	// Setting everybody (except anonymous and bots) as registered
	// TODO : check if this is what we want.
	user_group_auth('registered', 'SELECT user_id, {REGISTERED} FROM ' . 
		USERS_TABLE . ' WHERE user_id <> ' . ANONYMOUS . " AND group_id <> $bot_group_id", false);
	
	// Get parents forums
	// Will be used to ensure "read on path"
	$sql_parent_forums = 'SELECT forum_id, parent_id, forum_parents FROM ' 
	. FORUMS_TABLE . ";";
	$result_parent_forums = $db->sql_query($sql_parent_forums);
	while ($row = $src_db->sql_fetchrow($result_parent_forums))
	{
		$i_forum_id=$row['forum_id'];
		if ($forums[$i_forum_id]['id']==$i_forum_id)
		{
			$forums[$i_forum_id]['parent_id']=$row['parent_id'];
			$forums[$i_forum_id]['forum_parents']=$row['forum_parents'];
		}
	}
	$db->sql_freeresult($result_parent_forums);
		
	
	// Loop through forums
	foreach ($forums as $i_forum)
	{
		$i_forum_id=$i_forum['id'];
		$i_parent_forum_id=$i_forum['parent_id'];
				
		error_log("Parsing forum : $i_forum_id");
		
		// Administrators have full access to all forums whatever happens
		mass_auth('group_role', $i_forum_id, 'administrators', 'FORUM_FULL');		
		
		// global moderators have full access to all forums whatever happens
		mass_auth('group_role', $i_forum_id, 'global_moderators', 'FORUM_FULL');				
		
		// Administrators have full access to all forums whatever happens
		mass_auth('group_role', $i_parent_forum_id, 'administrators', 'FORUM_FULL');		
		
		// global moderators have full access to all forums whatever happens
		mass_auth('group_role', $i_parent_forum_id, 'global_moderators', 'FORUM_FULL');				

		foreach ( $ipb13_groups as $i_group )
		{
			$i_group_id=$i_group['id'];
			$i_group_name=$i_group['name'];
			
			//error_log("Parsing group : $i_group_name");

			// Documentation :
			//
			// Standard ipb group ids
			// 1 = validating
			// 2 = guests
			// 3 = Members
			// 4 = Admins
			// 5 = banned
			//
			// $ipb13_perms array structure
			// $ipb13_perms[$i_forum_id][$i_group_id]['start']=true;
			// $ipb13_perms[$i_forum_id][$i_group_id]['reply']=true;
			// $ipb13_perms[$i_forum_id][$i_group_id]['read']=true;
			// $ipb13_perms[$i_forum_id][$i_group_id]['upload']=true;
			//
			// mass auth usage fake examples (group_name and FORUM_AUTH do not exist)
			// Nota : group_name is taken as a true group name if it's a string
			//        but if it's an int then it's taken as a group id
			//
			// mass_auth('group_role', $i_forum_id, 'group_name', 'FORUM_STANDARD');
			// mass_auth('group_role', $i_forum_id, 'group_name', 'FORUM_LIMITED');
			// mass_auth('group_role', $i_forum_id, 'group_name', 'FORUM_READONLY');
			// mass_auth('group_role', $i_forum_id, 'group_name', 'FORUM_BOT');
			//
			// mass_auth('group_role', $i_forum_id, 'registered', 'FORUM_AUTH');
			// mass_auth('group_role', $i_forum_id, 'guests',     'FORUM_AUTH');
			// mass_auth('group_role', $i_forum_id, 'bots',       'FORUM_AUTH');
			// mass_auth('group_role', $i_forum_id, 'registered', 'FORUM_AUTH');
			// mass_auth('group_role', $i_forum_id, 'registered', 'FORUM_AUTH');
			
			// TODO : Give finer ACL from ipb masks to groups
			//        Currently we set only 2 Standard perms
			//        STANDARD if people can create topics
			//        READONLY if they can only read
			//        upload perms are not converted
			//        reply perms are not converted
			// TODO : check if svalidating (id = 1)
			//        Need some special processing		
			if ($i_group_id == 2) // Guests
			{
				// if at least read perm given to guests group : give also FORUM_BOT to bots group
				if ( $ipb13_perms[$i_forum_id][$i_group_id]['read']==true )
				{
					mass_auth('group_role', $i_forum_id, 'guests', 'FORUM_READONLY');
					mass_auth('group_role', $i_forum_id, 'bots',   'FORUM_BOT');

					mass_auth('group_role', $i_parent_forum_id, 'guests', 'FORUM_READONLY');
					mass_auth('group_role', $i_parent_forum_id, 'bots',   'FORUM_BOT');
					
				}				
			}
			else if ($i_group_id == 5)
			{
				// Banned => NOACCESS
				mass_auth('group_role', $i_forum_id, $i_group_id, 'FORUM_NOACCESS');
				mass_auth('group_role', $i_parent_forum_id, $i_group_id, 'FORUM_NOACCESS');
			}
			else if ($i_group_id == 3)
			{
				if ( $ipb13_perms[$i_forum_id][$i_group_id]['read']==true )
				{
					// Members => registered
					error_log("READ perms for group $i_group_name on $i_forum_id");
					mass_auth('group_role', $i_forum_id, 'registered', 'FORUM_READONLY');
					mass_auth('group_role', $i_parent_forum_id, 'registered', 'FORUM_READONLY');
				}
				if ( $ipb13_perms[$i_forum_id][$i_group_id]['start']==true )
				{
					error_log("STANDARD perms for group $i_group_name on $i_forum_id");
					mass_auth('group_role', $i_forum_id, 'registered', 'FORUM_STANDARD');
					mass_auth('group_role', $i_parent_forum_id, 'registered', 'FORUM_READONLY');
				}
			}
			else if ($i_group_id > 5)
			{
				// Custom groups
				if ( $ipb13_perms[$i_forum_id][$i_group_id]['read']==true )
				{
					error_log("READ perms for group $i_group_name on $i_forum_id");
					mass_auth('group_role', $i_forum_id, (int)$i_group_id, 'FORUM_READONLY');
					mass_auth('group_role', $i_parent_forum_id, (int)$i_group_id, 'FORUM_READONLY');
				}
				if ( $ipb13_perms[$i_forum_id][$i_group_id]['start']==true )
				{
					error_log("STANDARD perms for group $i_group_name on $i_forum_id");
					mass_auth('group_role', $i_forum_id, (int)$i_group_id, 'FORUM_STANDARD');
					mass_auth('group_role', $i_parent_forum_id, (int)$i_group_id, 'FORUM_READONLY');
				}
			}
		}		
	}
	
	// phpbb3 system groups roles

	// roles of admins

	mass_auth('group_role', 0, 'administrators', 'USER_FULL');

	mass_auth('group_role', 0, 'administrators', 'MOD_FULL');
		
	mass_auth('group_role', 0, 'administrators', 'ADMIN_FULL');

	// roles of global moderators

	mass_auth('group_role', 0, 'global_moderators', 'USER_FULL');

	mass_auth('group_role', 0, 'global_moderators', 'MOD_FULL');

	// roles of registered users = standard role

	mass_auth('group_role', 0, 'registered', 'USER_STANDARD');

	mass_auth('group_role', 0, 'registered_coppa', 'USER_STANDARD');

}

/**
* Set primary group.
* Really simple and only based on user_level (remaining groups will be assigned later)
*/
function phpbb_set_primary_group($group_id)
{
	global $convert_row;
	
	if ($group_id == 4)
	{
		return get_group_id('administrators');
	}
	else if ($group_id == 3)
	{
		return get_group_id('registered');
	}
	
	return 0;
}

function ipb13_user_is_active($group_id)
{
	if ( $group_id == 3 || $group_id == 4 )
	{
		$status=1;
	}
	else
	{
		$status=0;
	}
	return(set_user_type($status));
}

/**
* Convert the group name, making sure to avoid conflicts with 3.0 special groups
*/
function phpbb_convert_group_name($group_name)
{
	$default_groups = array(
		'GUESTS',
		'REGISTERED',
		'REGISTERED_COPPA',
		'GLOBAL_MODERATORS',
		'ADMINISTRATORS',
		'BOTS',
	);
	
	if (in_array(strtoupper($group_name), $default_groups))
	{
		return $group_name. "[ renamed ]";
	}
	
	return phpbb_set_default_encoding($group_name);
}

/**
* Convert the group type constants
*/
function phpbb_convert_group_type($group_type)
{
	switch ($group_type)
	{
		case 0:
		return GROUP_OPEN;
		break;
	
		case 1:
		return GROUP_CLOSED;
		break;
	
		case 2:
		return GROUP_HIDDEN;
		break;
}

// Never return GROUP_SPECIAL here, because only phpBB3's default groups are allowed to have this type set.
return GROUP_HIDDEN;
}

/**
 * Get phpbb rank id rom ipb rank string
 */

function phpbb_get_user_rank ( $ipb_title )
{
	global $config;
	
	if ( $ipb_title != '' )
	{
		global $db, $convert;
		
		// Create SQL for same db
		$sql = 'SELECT rank_id FROM ' . RANKS_TABLE . ' WHERE rank_title = "' . utf8_htmlspecialchars(phpbb_set_default_encoding($ipb_title)) . '"';
		
		$result = $db->sql_query_limit($sql, 1);
		
		$rank_id = (int) $db->sql_fetchfield('rank_id');
		$db->sql_freeresult($result);
		
		return $rank_id;
	}
	else
	{
		return 0;
	}
}


/**
 * Returns phpbb topic status according to ipb13
 */
function phpbb_convert_status($ipb_state)
{
	if ( $ipb_state == 'link' )
	{
		return ITEM_MOVED;
	}
	elseif ( $ipb_state == 'closed' )
	{
		return ITEM_LOCKED;
	}
	else
	{
		return ITEM_UNLOCKED;
	}
}

/**
* Gest the target topic id
*/
function phpbb_convert_moved_id($ipb_moved_to)
{
	$ipbmt_array = explode("&", $ipb_moved_to);
	return $ipbmt_array[0];
}

/**
* Convert the topic type constants
*/
function phpbb_convert_topic_type($topic_type)
{
	switch ($topic_type)
	{
		case 0:
		return POST_NORMAL;
		break;
	
		case 1:
		return POST_STICKY;
		break;
	
		case 2:
		return POST_ANNOUNCE;
		break;
	
		case 3:
		return POST_GLOBAL;
		break;
	}
	
	return POST_NORMAL;
}

function phpbb_replace_size($matches)
{
return '[size=' . min(200, ceil(100.0 * (((double) $matches[1])/12.0))) . ':' . $matches[2] . ']';
}

/**
* Reparse the message stripping out the bbcode_uid values and adding new ones and setting the bitfield
* @todo What do we want to do about HTML in messages - currently it gets converted to the entities, but there may be some objections to this
*/
function phpbb_prepare_message($message)
{
	global $phpbb_root_path, $phpEx, $db, $convert, $user, $config, $cache, $convert_row, $message_parser;
	
	if (!$message)
	{
		$convert->row['mp_bbcode_bitfield'] = $convert_row['mp_bbcode_bitfield'] = 0;
		return '';
	}
	
	// Already the new user id ;)
	$user_id = $convert->row['poster_id'];
	
	// IPB 13 smileys
	//<!--emo&:)--><img src='http://forums.grenouille.com/html/emoticons/smile.gif' border='0' style='vertical-align:middle' alt='smile.gif' /><!--endemo-->
	$message = preg_replace("/<!--emo&(.+)--><img src='.+\/([^\/']+)'[^>]+><!--endemo-->/siU", "<!-- s\\1 --><img src=\"{SMILIES_PATH}/\\2\" alt=\"\\1\" title=\"\\1\" /><!-- s\\1 -->",$message);

	// IPB 13 quotes
	//  <!--QuoteBegin-admin+Jul 7 2008, 04:19 PM--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> (admin &#064; Jul 7 2008, 04:19 PM)</td></tr><tr><td id='QUOTE'><!--QuoteEBegin--> test <!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd-->
	$message = preg_replace("/<!--QuoteBegin-[^-]+--><\/div><table [^>]*><tr><td><b>QUOTE<\/b> \(([^\)]+)\)<\/td><\/tr><tr><td id='QUOTE'><!--QuoteEBegin-->/siU","[quote=\"\\1\"]\r\n",$message);
	// <!--QuoteBegin--></div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE</b> </td></tr><tr><td id='QUOTE'><!--QuoteEBegin-->test<!--QuoteEnd--></td></tr></table><div class='postcolor'><!--QuoteEEnd-->aaaaaa 
	$message = preg_replace("/<!--QuoteBegin--><\/div><table border='0' align='center' width='95%' cellpadding='3' cellspacing='1'><tr><td><b>QUOTE<\/b> <\/td><\/tr><tr><td id='QUOTE'><!--QuoteEBegin-->/siU","\r\n[quote]\r\n",$message);
	$message = preg_replace("/<!--QuoteEnd--> *<\/td><\/tr><\/table><div [^>]*> *<!--QuoteEEnd-->/siU","\r\n[/quote]\r\n",$message);
	
	// IPB 13 code
	$message = preg_replace("/<!--c1--><\/div><table [^>]*><tr><td><b>CODE<\/b> *<\/td><\/tr><tr><td id='CODE'><!--ec1-->/siU","\r\n[code]\r\n",$message);
	$message = preg_replace("/<!--c2--><\/td><\/tr><\/table><div class='postcolor'><!--ec2-->/siU","\r\n[/code]\r\n",$message);
	
	// IPB 13 images
	//  <img src='http://www.antispam.aol.fr/images/global/logo_antispam.jpg' border='0' alt='user posted image' />
	$message = preg_replace("/<img src='([^']+)' .*alt='user posted image' *\/>/siU",'[img]\\1[/img]',$message);
	
	$message = str_replace('<i>', '[i]', $message);
	$message = str_replace('</i>', '[/i]', $message);
	$message = str_replace('<b>', '[b]', $message);
	$message = str_replace('</b>', '[/b]', $message);
	$message = str_replace('<u>', '[u]', $message);
	$message = str_replace('<br>',"\r\n",$message);
	$message = str_replace('<br />',"\r\n",$message);
	
	//$message = str_replace('<blockquote>','[quote]',$message);
	//$message = str_replace('</blockquote>','[/quote]',$message);
	$message = preg_replace('/<a href="http\:\/\/([\w\W]+)" target="_blank">([\w\W]+)<\/a>/siU','[url=http://\\1]\\2[/url]',$message);
	//$message = preg_replace('/<img src="style_emoticons\/<#EMO_DIR#>\/([\w\W]+)" style="vertical-align:middle" emoid="([\w\W]+)" border="0" alt="([\w\W]+)" \/>/siU','\\2',$message);
	//$message = preg_replace('/<!--quoteo\(post=([\d]+):date=([\w\W]+):name=([\w\W]+)\)-->/siU',"[quote=\"\\3\"]\r\n",$message);
	//$message = preg_replace('/<!--QuoteEnd--><\/div><!--QuoteEEnd-->/siU',"\r\n[/quote]\r\n",$message);
	//$message = str_replace('<div class=\'quotemain\'><!--quotec-->','',$message);
	//$message = preg_replace('/<div class=\'quotetop\'>([\w\W]+)<a href="([\w\W]+)">([\w\W]+)<\/a><\/div>/siU','',$message);
	$message = str_replace('</u>', '[/u]', $message);
	//$message = preg_replace('/<!--quoteo--><div class=\'quotetop\'>([\w\W]+)<\/div>/siU','[quote]',$message);

	if (strpos($message, '[quote=') !== false)
	{
		$message = preg_replace('/\[quote="(.*?)"\]/s', '[quote=&quot;\1&quot;]', $message);
		$message = preg_replace('/\[quote=\\\"(.*?)\\\"\]/s', '[quote=&quot;\1&quot;]', $message);
		
		// let's hope that this solves more problems than it causes. Deal with escaped quotes.
		$message = str_replace('\"', '&quot;', $message);
		$message = str_replace('\&quot;', '&quot;', $message);
	}
	
	// make the post UTF-8
	$message = phpbb_set_encoding($message);
	
	$enable_html = (!isset($row['enable_html'])) ? false : $row['enable_html'];
	//$enable_bbcode = (!isset($convert->row['enable_bbcode'])) ? true : $convert->row['enable_bbcode'];
	$enable_bbcode = true;
	//$enable_smilies = (!isset($convert->row['enable_smilies'])) ? true : $convert->row['enable_smilies'];
	$enable_smilies = true;
	//$enable_magic_url = (!isset($convert->row['enable_magic_url'])) ? true : $convert->row['enable_magic_url'];
	$enable_magic_url = true;
	
	$message_parser->warn_msg = array(); // Reset the errors from the previous message
	
	if ( isset($convert->row['msg_date']))
	{
		$message_parser->bbcode_uid = make_uid($convert->row['msg_date']);
	}
	elseif ( isset($convert->row['joined']))
	{
		$message_parser->bbcode_uid = make_uid($convert->row['joined']);
	}
	else
	{
		$message_parser->bbcode_uid = make_uid($convert->row['post_date']);
	}
	
	$message_parser->message = $message;
	unset($message);
	
	
	// Make sure options are set.
	//$message_parser->prepare_bbcodes();
	//$message_parser->parse_bbcode();

	// parse($allow_bbcode, $allow_magic_url, $allow_smilies, $allow_img_bbcode = true, $allow_flash_bbcode = true, $allow_quote_bbcode = true, $allow_url_bbcode = true, $update_this_message = true, $mode = 'post')
	$message_parser->parse($enable_bbcode, $enable_magic_url, $enable_smilies);
	
	if (sizeof($message_parser->warn_msg))
	{
		$msg_id = isset($convert->row['post_id']) ? $convert->row['post_id'] : $convert->row['privmsgs_id'];
		$convert->p_master->error('<span style="color:red">' . $user->lang['POST_ID'] . ': ' . $msg_id . ' ' . $user->lang['CONV_ERROR_MESSAGE_PARSER'] . ': <br /><br />' . implode('<br />', $message_parser->warn_msg), __LINE__, __FILE__, true);
	}
	
	$convert->row['mp_bbcode_bitfield'] = $convert_row['mp_bbcode_bitfield'] = $message_parser->bbcode_bitfield;
	
	//error_log("phpbb_prepare_message(".$msg_id."):".$convert_row['mp_bbcode_bitfield'], 0);
	
	$message = $message_parser->message;
	unset($message_parser->message);
	
	return $message;
}

/**
* Return the bitfield calculated by the previous function
*/
function get_bbcode_bitfield()
{
	global $convert_row;
	
	//error_log("get_bbcode_bitfield:".$convert_row['mp_bbcode_bitfield'], 0);
	
	return $convert_row['mp_bbcode_bitfield'];
}

/**
* Determine the last user to edit a post
* In practice we only tracked edits by the original poster in 2.0.x so this will only be set if they had edited their own post
*/
function phpbb_post_edit_user()
{
	global $convert_row, $config;
	
	if (isset($convert_row['post_edit_count']))
	{
		return phpbb_user_id($convert_row['poster_id']);
	}
	
	return 0;
}

/**
* Obtain the path to uploaded files on the 2.0.x forum
* This is only used if the Attachment MOD was installed
*/
function phpbb_get_files_dir()
{
	global $src_db, $same_db, $convert, $user, $config, $cache;
	
	$sql = 'SELECT conf_value AS upload_dir
		FROM ' . $convert->src_table_prefix . "conf_settings
		WHERE conf_key = 'upload_dir'";
	$result = $src_db->sql_query($sql);
	$upload_path = $src_db->sql_fetchfield('upload_dir');
	$src_db->sql_freeresult($result);
	
	return $upload_path;
}

/**
* Copy thumbnails of uploaded images from the 2.0.x forum
* This is only used if the Attachment MOD was installed
*/
function phpbb_copy_thumbnails()
{
	global $db, $convert, $user, $config, $cache, $phpbb_root_path;
	
	$src_path = $convert->options['forum_path'] . '/' . phpbb_get_files_dir() . '/thumbs/';
	
	if ($handle = @opendir($src_path))
	{
		while ($entry = readdir($handle))
		{
		if ($entry[0] == '.')
		{
		continue;
		}
	
		if (is_dir($src_path . $entry))
		{
		continue;
		}
		else
		{
		copy_file($src_path . $entry, $config['upload_path'] . '/' . preg_replace('/^t_/', 'thumb_', $entry));
		@unlink($phpbb_root_path . $config['upload_path'] . '/thumbs/' . $entry);
		}
		}
		closedir($handle);
	}
}

/**
* Convert the attachment category constants
* This is only used if the Attachment MOD was installed
*/
function phpbb_attachment_category($cat_id)
{
	switch ($cat_id)
	{
		case 1:
		return ATTACHMENT_CATEGORY_IMAGE;
		break;
	
		case 2:
		return ATTACHMENT_CATEGORY_WM;
		break;
	
		case 3:
		return ATTACHMENT_CATEGORY_FLASH;
		break;
	}
	
	return ATTACHMENT_CATEGORY_NONE;
}

/**
* Obtain list of forums in which different attachment categories can be used
*/
function phpbb_attachment_forum_perms($forum_permissions)
{
	if (empty($forum_permissions))
	{
		return '';
	}
	
	// Decode forum permissions
	$forum_ids = array();
	
	$one_char_encoding = '#';
	$two_char_encoding = '.';
	
	$auth_len = 1;
	for ($pos = 0; $pos < strlen($forum_permissions); $pos += $auth_len)
	{
		$forum_auth = substr($forum_permissions, $pos, 1);
		if ($forum_auth == $one_char_encoding)
		{
		$auth_len = 1;
		continue;
		}
		else if ($forum_auth == $two_char_encoding)
		{
		$auth_len = 2;
		$pos--;
		continue;
		}
		
		$forum_auth = substr($forum_permissions, $pos, $auth_len);
		$forum_id = base64_unpack($forum_auth);
	
		$forum_ids[] = (int) $forum_id;
	}
	
	if (sizeof($forum_ids))
	{
		return attachment_forum_perms($forum_ids);
	}
	
	return '';
}

/**
* Convert the avatar type constants
*/
function phpbb_avatar_type($type)
{
	switch ($type)
	{
		case 'upload':
		case 'local':
		return AVATAR_UPLOAD;
		break;
	
		case 'url':
		return AVATAR_REMOTE;
		break;
	
		case 3:
		return AVATAR_GALLERY;
		break;
	}
	
	return 0;
}

function ipb_avatar_type($avatar)
{
	if ( preg_match('/^upload:/', $avatar))
	{
		return AVATAR_UPLOAD;
	}
	elseif ( preg_match('/^http:\/\//', $avatar) || preg_match('/^https:\/\//', $avatar))
	{
		return AVATAR_REMOTE;
	}
	else
	{
		//return AVATAR_GALLERY;
		return 0;
	}
}

/**
* Just undos the replacing of '<' and '>'
*/
function  phpbb_smilie_html_decode($code)
{
	$code = str_replace('&lt;', '<', $code);
	return str_replace('&gt;', '>', $code);
}

/**
* Transfer avatars, copying the image if it was uploaded
*/
function phpbb_import_avatar($user_avatar)
{
	global $db, $convert, $user, $config, $cache, $phpbb_root_path, $convert_row;
		
	if ( preg_match('/^upload:/', $user_avatar))
	{
		$src_path = 'uploads/';
		$image=preg_replace("/^upload:/","",$user_avatar);
		
		$user_id=phpbb_user_id($convert_row['id']);
		$image_extension=substr(strrchr($image, '.'), 1);
		$suffix = "_" . time();
		$prefix = $config['avatar_salt'] . '_';
		
		$new_avatar_field= $user_id . $suffix . "." . $image_extension;
		$new_image_file = $prefix . $user_id . "." . $image_extension;
		
		copy_file($src_path . $image, 'images/avatars/upload/' . $new_image_file, true);
		
		return $new_avatar_field;
	}
	else
	{
		return $user_avatar;
	}
}


function phpbb_get_attachement_filesize ($attachement_filename)
{
	global $db, $convert, $user, $config, $cache, $phpbb_root_path;
	
	return filesize($convert->options['forum_path'] . '/uploads/' . $attachement_filename);
}

function phpbb_import_attachement ($attachement_filename)
{
	global $db, $convert, $user, $config, $cache, $phpbb_root_path;
	
	$src_path = 'uploads/';
	copy_file($src_path . $attachement_filename, $config['upload_path'].'/' . $attachement_filename, true);
	
	return $attachement_filename;
}

function phpbb_get_attachement_extension ($ipb_attach_file)
{
	$extension=substr(strrchr($ipb_attach_file, '.'), 1);
	return $extension;
}

function phpbb_get_attachement_mimetype ($ipb_attach_type)
{
	return $ipb_attach_type;
}

function phpbb_has_attachement ($attachement_filename)
{
	if ( $attachement_filename != "")
		return 1;
	return 0;
}

function phpbb_birthday($user_id)
{
	global $src_db, $convert;
		$sql = 'SELECT bday_day, bday_month, bday_year
		FROM ' . $convert->src_table_prefix . "members
		WHERE id=".$user_id;
	$result = $src_db->sql_query($sql);
	while($row=$src_db->sql_fetchrow($result))
	{
	$day = $row['bday_day'];
	$month = $row['bday_month'];
	$year = $row['bday_year'];
	}
	$src_db->sql_freeresult($result);
	return $day.'-'.$month.'-'.$year;
}

/**
* Find out about the avatar's dimensions
*/
function phpbb_get_avatar_height($user_avatar)
{
	$dims=explode('x',$user_avatar);
	return $dims[1];
}


/**
* Find out about the avatar's dimensions
*/
function phpbb_get_avatar_width($user_avatar)
{
	$dims=explode('x',$user_avatar);
	return $dims[0];
}


/**
* Copy the the smiley file to phpbb's smileys dir
* IPB_ROOT."/html/emoticons/".$image -> $phpbb_root_path."/images/smilies"
*/
function copy_smiley_from_ipb_dir($image)
{
	global $db, $convert, $user, $config, $cache, $phpbb_root_path;
	
	$src_path = 'html/emoticons/';
	
	copy_file($src_path . $image, 'images/smilies/' . $image, true);
	
	return $image;
}

/**
* Find out about the smiley's width
*/
function get_ipb_smiley_width($image)
{
	global $db, $convert, $user, $config, $cache, $phpbb_root_path;
	
	$image_url = $convert->options['forum_path'] . '/html/emoticons/'.$image;
	
	list($width, $height, $type, $attr) = getimagesize($image_url);
	return $width;
}

/**
* Find out about the smiley's height
*/
function get_ipb_smiley_height($image)
{
	global $db, $convert, $user, $config, $cache, $phpbb_root_path;
	
	$image_url = $convert->options['forum_path'] . '/html/emoticons/'.$image;
	
	list($width, $height, $type, $attr) = getimagesize($image_url);
	return $height;
}



/**
* Calculate the correct to_address field for private messages
*/
function phpbb_privmsgs_to_userid($to_userid)
{
	global $config;
	
	return 'u_' . phpbb_user_id($to_userid);
}

/**
* Calculate whether a private message was unread using the bitfield
*/
function phpbb_unread_pm($pm_type)
{
	return ($pm_type == 5) ? 1 : 0;
}

/**
* Calculate whether a private message was new using the bitfield
*/
function phpbb_new_pm($pm_type)
{
	return ($pm_type == 1) ? 1 : 0;
}

/**
* Obtain the folder_id for the custom folder created to replace the savebox from 2.0.x (used to store saved private messages)
*/
function phpbb_get_savebox_id($user_id)
{
	global $db;
	
	$user_id = phpbb_user_id($user_id);
	
	// Only one custom folder, check only one
	$sql = 'SELECT folder_id
		FROM ' . PRIVMSGS_FOLDER_TABLE . '
		WHERE user_id = ' . $user_id;
	$result = $db->sql_query_limit($sql, 1);
	$folder_id = (int) $db->sql_fetchfield('folder_id');
	$db->sql_freeresult($result);
	
	return $folder_id;
}

/**
* Transfer attachment specific configuration options
* These were not stored in the main config table on 2.0.x
* This is only used if the Attachment MOD was installed
*/
function phpbb_import_attach_config()
{
	global $db, $src_db, $same_db, $convert, $config;
	
	if ($convert->mysql_convert && $same_db)
	{
		$src_db->sql_query("SET NAMES 'binary'");
	}
	
	$sql = 'SELECT *
		FROM ' . $convert->src_table_prefix . 'attachments_config';
	$result = $src_db->sql_query($sql);
	
	if ($convert->mysql_convert && $same_db)
	{
		$src_db->sql_query("SET NAMES 'utf8'");
	}
	
	$attach_config = array();
	while ($row = $src_db->sql_fetchrow($result))
	{
		$attach_config[$row['config_name']] = $row['config_value'];
	}
	$src_db->sql_freeresult($result);
	
	set_config('allow_attachments', 1);
	
	// old attachment mod? Must be very old if this entry do not exist...
	if (!empty($attach_config['display_order']))
	{
		set_config('display_order', $attach_config['display_order']);
	}
	set_config('max_filesize', $attach_config['max_filesize']);
	set_config('max_filesize_pm', $attach_config['max_filesize_pm']);
	set_config('attachment_quota', $attach_config['attachment_quota']);
	set_config('max_attachments', $attach_config['max_attachments']);
	set_config('max_attachments_pm', $attach_config['max_attachments_pm']);
	set_config('allow_pm_attach', $attach_config['allow_pm_attach']);
	
	set_config('img_display_inlined', $attach_config['img_display_inlined']);
	set_config('img_max_width', $attach_config['img_max_width']);
	set_config('img_max_height', $attach_config['img_max_height']);
	set_config('img_link_width', $attach_config['img_link_width']);
	set_config('img_link_height', $attach_config['img_link_height']);
	set_config('img_create_thumbnail', $attach_config['img_create_thumbnail']);
	set_config('img_max_thumb_width', 400);
	set_config('img_min_thumb_filesize', $attach_config['img_min_thumb_filesize']);
	set_config('img_imagick', $attach_config['img_imagick']);
}

/**
* Calculate the date a user became inactive
*/
function phpbb_inactive_time()
{
	global $convert_row;
	
	if ($convert_row['user_active'])
	{
		return 0;
	}
	
	if ($convert_row['user_lastvisit'])
	{
		return $convert_row['user_lastvisit'];
	}
	
	return $convert_row['user_regdate'];
}

/**
* Calculate the reason a user became inactive
* We can't actually tell the difference between a manual deactivation and one for profile changes
* from the data available to assume the latter
*/
function phpbb_inactive_reason()
{
	global $convert_row;
	
	if ($convert_row['user_active'])
	{
		return 0;
	}
	
	if ($convert_row['user_lastvisit'])
	{
		return INACTIVE_PROFILE;
	}
	
	return INACTIVE_REGISTER;
}

/**
* Adjust 2.0.x disallowed names to 3.0.x format
*/
function phpbb_disallowed_username($username)
{
	// Replace * with %
	$username = phpbb_set_default_encoding(str_replace('*', '%', $username));
	return utf8_htmlspecialchars($username);
}

function phpbb_set_clean_name($name)
{
	return utf8_strtolower(phpbb_set_default_encoding($name));;
}

